﻿checkRequire("Lua_JinJieUtil")
checkRequire("Lua_JinJieInfItem2")
checkRequire("Lua_JinJieInfItem1")
checkRequire("Lua_JinJieItem")
Lua_JinJiePanel = class("Lua_JinJiePanel", Lua_DisplayObject);
function Lua_JinJiePanel:ctor(p)
	self:superCall("ctor", p, "JinJiePanel_skin");
end

function Lua_JinJiePanel:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("onJinJieCellClick", self, self.onJinJieCellClick);
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);
	self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent);

	self.redDot:setEnable(false);

	self.jinjie_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 500));
	self.jinjie_DragList:setListCell(Lua_JinJieItem, 116, 286, 1);
	self.jinjie_DragList:setLocation(-460, -85, 0);

	self.jinjieinf_DragList1 = Lua_DragList.new(self.content, 1, Vector4(0, 0, 238, 216));
	self.jinjieinf_DragList1:setListCell(Lua_JinJieInfItem1, 30, 238, 1);
	self.jinjieinf_DragList1:setLocation(-88, -100, 0);

	self.jinjieinf_DragList2 = Lua_DragList.new(self.content, 1, Vector4(0, 0, 238, 216));
	self.jinjieinf_DragList2:setListCell(Lua_JinJieInfItem2, 30, 238, 1);
	self.jinjieinf_DragList2:setLocation(313, -100, 0);

	self.Arr = Array();
	self.Arr1 = Array();
	self.Arr2 = Array();
	self.equipArr = DataCenter.equData.parts;
	self.jinJiePart = Lua_JinJieUtil.getJinJiePartList();
	if #self.equipArr ~= 0 then
		for i = 12, 1, -1 do
			for k, v in pairs(self.jinJiePart) do
				if i == v then
					local _eq = DataCenter.equData:getEquByPart(i);
					if _eq ~= nil then
						_eq.color_name = Lua_JinJieUtil.getColor(_eq.color)
						if _eq.order >= Lua_JinJieUtil.getClass_limit() and _eq.color >= Lua_JinJieUtil.getColor_limit()
							and _eq.star >= Lua_JinJieUtil.getStar_limit() and _eq.order < Lua_JinJieUtil.getMax_class() then
							self.Arr1:add(_eq);
						else
							self.Arr2:add(_eq);
						end
					else
						self.Arr2:add({id = DataCenter.equData.parts[i].id, selected = DataCenter.equData.parts[i].selected,
							equPart = DataCenter.equData.parts[i].equPart, polish_open = DataCenter.equData.parts[i].polish_open});
					end
				end
			end
		end
	end
	for i = 1, self.Arr1:getSize() do
		self.Arr:add(self.Arr1[i]);
	end
	for i = 1, self.Arr2:getSize() do
		self.Arr:add(self.Arr2[i]);
	end
	self.jinjie_DragList:setLuaArrayData(self.Arr, false);

	self.length = self.jinjie_DragList.showList:getSize();
	if self.length ~= 0 then
		self.jinjie_DragList.showList[1]:onPlayerSoundClick();
		self.jinjie_DragList:setSelected(1);
	end

	self.jinJieBtn:addClickFuntion(self, self.onJinJieClick);
	self.tipsIcon:addClickFuntion(self, self.onHelpClick);
end

function Lua_JinJiePanel:onUpdateView()
	self.Arr:clear();
	self.Arr1:clear();
	self.Arr2:clear();
	self.equipArr = DataCenter.equData.parts;
	self.jinJiePart = Lua_JinJieUtil.getJinJiePartList();
	if #self.equipArr ~= 0 then
		for i = 12, 1, -1 do
			for k, v in pairs(self.jinJiePart) do
				if i == v then
					local _eq = DataCenter.equData:getEquByPart(i);
					if _eq ~= nil then
						_eq.color_name = Lua_JinJieUtil.getColor(_eq.color);
						if _eq.order >= Lua_JinJieUtil.getClass_limit() and _eq.color >= Lua_JinJieUtil.getColor_limit()
							and _eq.star >= Lua_JinJieUtil.getStar_limit() and _eq.order < Lua_JinJieUtil.getMax_class() then
							self.Arr1:add(_eq);
						else
							self.Arr2:add(_eq);
						end
					else
						self.Arr2:add({id = DataCenter.equData.parts[i].id, selected = DataCenter.equData.parts[i].selected,
							equPart = DataCenter.equData.parts[i].equPart, polish_open = DataCenter.equData.parts[i].polish_open});
					end
				end
			end
		end

		for i = 1, self.Arr1:getSize() do
			self.Arr:add(self.Arr1[i]);
		end
		for i = 1, self.Arr2:getSize() do
			self.Arr:add(self.Arr2[i]);
		end
		for i = 1, self.Arr:getSize() do
			if self.data.equPart == self.Arr[i].equPart then
				self.data = self.Arr[i];
				self.Arr[i].selected = true;
			else
				self.Arr[i].selected = false;
			end
		end
	end
	self.jinjie_DragList:setLuaArrayData(self.Arr, false);
	self:onShowInfo();
end

function Lua_JinJiePanel:onJinJieCellClick(data)
	self.data = data;
	if self.data == nil then
		return;
	end
	self:onShowInfo();
end

function Lua_JinJiePanel:onSuccessEvent()
	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.jinJieJianTou.mainContent, "/effects/scsEffects/gui_jingjiechenggong", "gui_jingjiechenggong", 0, 110);
		self.effectZiTi:SetRenderQueue(self.jinJieJianTou, 5, 2, false);
	end
	self.effectZiTi:setEnable(false);
	self.effectZiTi:setEnable(true);
end

function Lua_JinJiePanel:onShowInfo()
	if self.equipImg ~= nil then
		self.equipImg.data = nil;
		self.equipImg:showLockSlot(false);
	end

	if self.equipImg2 ~= nil then
		self.equipImg2.data = nil;
		self.equipImg2:showLockSlot(false);
	end

	if self.costImg ~= nil then
		self.costImg.data = nil;
		self.costImg:showLockSlot(false);
	end

	if self.data.isLock == true or self.data.id == 0 then
		self:showLock();
	elseif self.data.order >= Lua_JinJieUtil.getMax_class() then
		self:showLock();
	else
		-- 进阶前
		self.jinjieinf_DragList1:setEnable(true);
		self.jinjieinf_DragList2:setEnable(true);
		self.jinJieBtn:setGray(false);
		self.jinJieBtn:addClickFuntion(self, self.onJinJieClick);
		
		self.equipImgVo = Lua_ToolVo.createToolVo(self.data.id);
		self.equipImgVo.color_name = Lua_JinJieUtil.getColor(self.equipImgVo.color);
		self.equipImgVo.star = self.data.star;
		self.equipImgVo.packTpe = self.data.packTpe;
		self.equipImgVo.equipment = self.data.equipment;
		if self.equipImg == nil then
			self.equipImg = Lua_ToolImage.new(self.jinJieForging_duanzao1.mainContent);
			self.equipImg:setDepth(8);
			self.equipImg:showLockSlot(false);
		end
		self.equipImg.data = self.equipImgVo;

		local obj;
		local str;
		local arr = Array();
		arr:add(LanUtil.formateStr(LanUtil.getValue(120560), "[00E125]" .. self.equipImg.data.order));
		arr:add(LanUtil.formateStr(LanUtil.getValue(120561), "[00E125]" .. self.equipImg.data.color_name));
		for i = 1, self.equipImg.data.baseAttr:getSize() do
			obj = self.equipImg.data.baseAttr[i];
			if obj.attack_max ~= nil then
				str = "[85A8BE]"..obj.ChineseName.."：[-][00E125]"..obj.attack_min.."-"..obj.attack_max;
			else
				str = "[85A8BE]"..obj.ChineseName.."：[-][00E125]"..obj.value;
			end
			arr:add(str);
		end
		arr:add(LanUtil.formateStr(LanUtil.getValue(120564), "[00E125]" .. DataCenter.equData:getJewf_countByPart(self.data.equPart)));
		self.jinjieinf_DragList1:setLuaArrayData(arr, false);

		-- 进阶后
		self.equipImg2Vo = Lua_ToolVo.createToolVo(self.data.id + 1);
		self.equipImg2Vo.color_name = Lua_JinJieUtil.getColor(self.equipImg2Vo.color);
		self.equipImg2Vo.star = self.data.star;
		self.equipImg2Vo.packTpe = self.data.packTpe;
		self.equipImg2Vo.equipment = self.data.equipment;
		if self.equipImg2 == nil then
			self.equipImg2 = Lua_ToolImage.new(self.jinJieForging_duanzao3.mainContent);
			self.equipImg2:setDepth(8);
			self.equipImg2:showLockSlot(false);
		end
		self.equipImg2.data = self.equipImg2Vo;
		
		local Arr2 = Array()
		Arr2:add(LanUtil.formateStr(LanUtil.getValue(120560), "[00E125]" .. self.equipImg2.data.order));
		Arr2:add(LanUtil.formateStr(LanUtil.getValue(120561), "[00E125]" .. self.equipImg2.data.color_name));
		for i = 1, self.equipImg2.data.baseAttr:getSize() do
			obj = self.equipImg2.data.baseAttr[i];
			if obj.attack_max ~= nil then
				str = "[85A8BE]"..obj.ChineseName.."：[-][00E125]"..obj.attack_min.."-"..obj.attack_max;
			else
				str = "[85A8BE]"..obj.ChineseName.."：[-][00E125]"..obj.value;
			end
			Arr2:add(str);
		end

		local list = Lua_JinJieUtil.getjewel_holeCountList();
		local isUp = false;
		for i = 1, list:getSize() do
			if self.data.order == (list[i] - 1) then
				Arr2:add(LanUtil.formateStr(LanUtil.getValue(120564), "[00E125]"..(DataCenter.equData:getJewf_countByPart(self.data.equPart) + 1)));
				isUp = true;
			end
		end

		if isUp ~= true then
			Arr2:add(LanUtil.formateStr(LanUtil.getValue(120564), "[00E125]"..DataCenter.equData:getJewf_countByPart(self.data.equPart)));
		end
		self.jinjieinf_DragList2:setLuaArrayData(Arr2, false);

		-- 进阶材料
		local costId = Lua_JinJieUtil.getCostid(self.data.equPart, self.data.order);
		local costAmount = Lua_JinJieUtil.getCostcount(self.data.equPart, self.data.order);
		local curNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costId);
		if self.costImg == nil then
			self.costImg = Lua_ToolImage.new(self.jinJieForging_duanzao2.mainContent);
			self.costImg:setDepth(8);
			self.costImg:showLockSlot(false);
		end
		self.costImg.data = Lua_ToolVo.createToolVo(costId, costAmount);
		self.costImg:showNumLimit(curNum, costAmount, 2);

		self.redDot:setEnable(self:checkRedDot());
    end
end

function Lua_JinJiePanel:showLock()
	if self.equipImg == nil then
		self.equipImg = Lua_ToolImage.new(self.jinJieForging_duanzao1.mainContent);
		self.equipImg:setDepth(8);
	end
	self.equipImg:showLockSlot(true);

	if self.equipImg2 == nil then
		self.equipImg2 = Lua_ToolImage.new(self.jinJieForging_duanzao3.mainContent);
		self.equipImg2:setDepth(8);
	end
	self.equipImg2:showLockSlot(true);

	if self.costImg == nil then
		self.costImg = Lua_ToolImage.new(self.jinJieForging_duanzao2.mainContent);
		self.costImg:setDepth(8);
	end
	self.costImg:showLockSlot(true);

	self.jinjieinf_DragList1:setEnable(false);
	self.jinjieinf_DragList2:setEnable(false);
	self.jinJieBtn:setGray(true);
	self.jinJieBtn:removeClickFuntion(self, self.onJinJieClick);
	self.redDot:setEnable(false);
end

function Lua_JinJiePanel:checkRedDot()
	if self.data == nil or self.data.color < Lua_JinJieUtil.getColor_limit() or self.data.star < Lua_JinJieUtil.getStar_limit() then
		return false;
	else
		local costId = Lua_JinJieUtil.getCostid(self.data.equPart, self.data.order);
		local costAmount = Lua_JinJieUtil.getCostcount(self.data.equPart, self.data.order);
		local curNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costId);
		return curNum >= costAmount;
	end
end

function Lua_JinJiePanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(120558));
end

function Lua_JinJiePanel:onJinJieClick()
	if self.data == nil or self.data.color < Lua_JinJieUtil.getColor_limit() or self.data.star < Lua_JinJieUtil.getStar_limit() then
		return;
	end

	local costId = Lua_JinJieUtil.getCostid(self.data.equPart, self.data.order);
	local costAmount = Lua_JinJieUtil.getCostcount(self.data.equPart, self.data.order);
	local curNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costId);
	self.force_advance = 0;
	if curNum >= costAmount then
		if DataCenter.roleData.level < self.equipImg2.data.useLvl or DataCenter.roleData.profession < self.equipImg2.data.profession then
			self.force_advance = 1;
			local tipData = {};
			tipData.owner = self;
			tipData.titleName = LanUtil.getValue(124443);
			tipData.des = LanUtil.getValue(120568);
			tipData.equipData = self.data;
			tipData.type = 1;
			tipData.cancelName = LanUtil.getValue(120545);
			tipData.subName = LanUtil.getValue(10008);
			tipData.subFun = self.showTipsWin;
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		else
			self:showTipsWin();
		end
	else
		local arr = Array();
		arr:add(Lua_ToolVo.new(costId));
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_JinJiePanel:showTipsWin()
	local equip = DataCenter.equData:getEquByPart(self.data.part);
	if equip ~= nil then
		if equip.refine == 0 or equip.career == 0 then
			self:onSubCallback();
		else
			local refineCount = DataCenter.equData:getRefineCount(equip, equip.refine, v);
			if refineCount < 2 then
				self:onSubCallback();
			else
				local tipData = {};
				tipData.owner = self;
				tipData.titleName = LanUtil.getValue(124443);
				tipData.des = LanUtil.formateStr(LanUtil.getValue(120565), self:getSuitName(), tostring(refineCount));
				tipData.equipData = self.data;
				tipData.type = 1;
				tipData.cancelName = LanUtil.getValue(120545);
				tipData.subName = LanUtil.getValue(10008);
				tipData.subFun = self.onSubCallback;
				Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
			end
		end
	end
end

function Lua_JinJiePanel:getSuitName()
	if self.data == nil then
		return;
	end

	local _strName;
	if self.data.refine == 1 then
		_strName = LanUtil.getValue(120566);
	else
		_strName = LanUtil.getValue(120567);
	end

	if self.data.career == 0 then
		_strName = _strName .. Lua_CuiLianUtil.getRefine_name(4, self.data.order);
	else
		_strName = _strName .. Lua_CuiLianUtil.getRefine_name(DataCenter.roleData.career, self.data.order);
	end
	return _strName;
end

function Lua_JinJiePanel:onSubCallback()
	local cmd = ProtoPublic_pb.Proto11400627();
	cmd.equipment_part = self.data.equPart;
	cmd.force_advance = self.force_advance;
	sendMsg(11400627, cmd);
end

function Lua_JinJiePanel:dispose()
	if self.jinjie_DragList ~= nil then
		self.jinjie_DragList:dispose();
		self.jinjie_DragList = nil;
	end
	if self.jinjieinf_DragList1 ~= nil then
		self.jinjieinf_DragList1:dispose();
		self.jinjieinf_DragList1 = nil;
	end
	if self.jinjieinf_DragList2 ~= nil then
		self.jinjieinf_DragList2:dispose();
		self.jinjieinf_DragList2 = nil;
	end

	self:superCall("dispose");
end