﻿checkRequire("Lua_MingKeItem")
Lua_MingKePanel = class("Lua_MingKePanel", Lua_DisplayObject);
function Lua_MingKePanel:ctor(p)
    self:superCall("ctor", p, "MingKePanel_skin");
end
function Lua_MingKePanel:buildShowItem()
    self:superCall("buildShowItem");
    self.jingLianClickBtn:addClickFuntion(self, self.onJingLianClickBtn)
    self.lab_003_chat:addClickFuntion(self, self.onHelpClick)
    self.iconBg:addClickFuntion(self, self.onIconBgClick)
    self.jingLianClickBtn:setEnable(false)
    self.tipsLbl.text = "";
    self.maxTxt:setEnable(false)
    self:addLuaEvent("onJingLianCellClick", self, self.onJingLianCellClick)
    self:addLuaEvent("FORGING_PLAY_SUCCEED", self, self.onSuccessEvent)
    self.ItemList = Array()
    self.suo_Arr = Array()
    self.cur_Attr = Array()
    self.next_Attr = Array()

    self.suo_Arr:add(self.suo1);
    self.suo_Arr:add(self.suo2);
    self.suo_Arr:add(self.suo3);
    self.suo_Arr:add(self.suo4);
    self.suo_Arr:add(self.suo6);
    self.suo_Arr:add(self.suo5);
    self.duanzaoBG_Arr = Array()
    self.duanzaoBG_Arr:add(self.forging_duanzao1);
    self.duanzaoBG_Arr:add(self.forging_duanzao2);
    self.duanzaoBG_Arr:add(self.forging_duanzao3);
    self.duanzaoBG_Arr:add(self.forging_duanzao4);
    self.duanzaoBG_Arr:add(self.forging_duanzao6);
    self.duanzaoBG_Arr:add(self.forging_duanzao5);
    self.openLbl_Arr = Array();
    self.openLbl_Arr:add(self.openLbl1);
    self.openLbl_Arr:add(self.openLbl2);
    self.openLbl_Arr:add(self.openLbl3);
    self.openLbl_Arr:add(self.openLbl4);
    self.openLbl_Arr:add(self.openLbl6);
    self.openLbl_Arr:add(self.openLbl5);

    self.suo_Arr[1].mainContent:SetActive(false);
    self.suo_Arr[2].mainContent:SetActive(false);

    self.redDot = UICreate.createUIAtlasImage(self.jingLianClickBtn.mainContent, "iconantlas4", "redDot", 60, 16, 0, 0)
    self.redDot:setDepth(6);
    self.redDot.clickScale = false;
    self.redDot.name = "redDot"
    self.redDot:setEnable(false);

    self:createDragList()
    self:setListData()
    if self.Arr:getSize() > 0 then
        self.jingLian_DragList.showList[1]:onPlayerSoundClick();
        self.jingLian_DragList:setSelected(1);
    end
    self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView)
end
function Lua_MingKePanel:createDragList()
    self.jingLian_DragList = Lua_DragList.new(self.content, 1, Vector4(-106, -226, 340, 530));
    self.jingLian_DragList:setLocation(-338, 170, 0);
    self.jingLian_DragList:setListCell(Lua_MingKeItem, 115, 340, 1);
    self.jingLian_DragList.canDrag = true;
end

function Lua_MingKePanel:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(140908));
end

function Lua_MingKePanel:onIconBgClick()
    if self.data ~= nil then
        Lua_WindowUtil.openWin("Lua_MingKeTipsWindow", WinParam.ACTION_AUTO, self.mingKeConfig);
    else
        OperateAlert.show(LanUtil.getValue(140911));
    end
end

function Lua_MingKePanel:onJingLianClickBtn()
    if self.data == nil then
        return
    end
    self.curPart = self.data.equPart;
    self:onSendMsg()
end

function Lua_MingKePanel:onSendMsg()
    if self.costItemId == 0 then
        if self.selectedIndex ~= nil then
            local cmd = getProtoMsg("Proto11400635");
            cmd.part = self.data.equPart;
            cmd.jewel_hole = self.selectedIndex - 1
            sendMsg(11400635, cmd)
        else
            OperateAlert.show(LanUtil.getValue(140904));
        end
    else
        local arr = Array();
        arr:add(Lua_ToolVo.new(self.costItemId));
        Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
    end
end

function Lua_MingKePanel:onSuccessEvent()
    if self.effect == nil then
        self.effect = UICreate.createUIEffect(self.forging_quan2.mainContent, "/effects/scsEffects/gui_mingkechenggong", "gui_mingkechenggong", 0, 0);
    else
        self.effect.mainContent:SetActive(false);
        self.effect.mainContent:SetActive(true);
    end
    self.effect:SetRenderQueue(self.lvlText, 15, 2, false);
end

function Lua_MingKePanel:onJingLianCellClick(data)
    self.data = data
    if self.curPart == self.data.equPart then
        return
    end
    self:createEquipItem()
end

function Lua_MingKePanel:onUpdateView()
    self:setListData()
    local len = self.Arr:getSize()
    for i = 1, len do
        if self.data.equPart == self.Arr[i].equPart then
            self.data = self.Arr[i]
            break
        end
    end
    self:createEquipItem()
end
function Lua_MingKePanel:setListData()
    self.Arr = Array();
    for i = 12, 1, -1 do
        local _eq = DataCenter.equData:getEquByPart(i);
        if _eq ~= nil and _eq.hasJewl == true then
            self.Arr:add(_eq);
        end
    end
    self.jingLian_DragList:setLuaArrayData(self.Arr, false);
end 

function Lua_MingKePanel:createEquipItem()
    if self.data == nil then
        return
    end
    if self.rightEquipItem == nil then
        self.rightEquipItem = Lua_ToolImage.new(self.forging_quan2.mainContent);
        self.rightEquipItem:setDepth(4);
        self.rightEquipItem:setLocation(0, 0, 0);
    end
    self.rightEquipItem.data = self.data
    self.lvlText.text = LanUtil.formateStr(LanUtil.getValue(120581), tostring(self.data.jewl_Level))
    ----------------------------------------------------------------------------
    if self.goArr == nil then
        self.goArr = { };
    else
        local len = #self.goArr
        for i = 1, len do
            if self.goArr[i].item ~= nil then
                self.goArr[i].item:dispose();
                self.goArr[i].selected_mask:dispose();
                self.goArr[i].redDot:dispose();
                self.goArr[i] = nil
            end
        end
    end
    self.count = DataCenter.equData:getJewf_countHoleByPart(self.data.equPart);
    for i = 1, self.count do
        local index = i;
        if i == 5 then
            index = i + 1
        elseif i == 6 then
            index = i - 1
        end
        local list = { }
        list.index = i
        if self.data.jewel[i].id > 0 then
            local jewfImg = Lua_ToolImage.new(self.duanzaoBG_Arr[index].mainContent);
            jewfImg:setDepth(6);
            jewfImg:setLocation(0, 0, 0);
            jewfImg.content.name = i;
            jewfImg:setCanClick(true);
            jewfImg.data = Lua_ToolVo.new(self.data.jewel[i].id, 0, 0);
            jewfImg:removeFun(false)
            jewfImg.item_bg:addClickFuntion(self, self.onIconClick);
            local selected_mask = UICreate.createUIAtlasImage(jewfImg.item_bg.mainContent, "forgingWindow", "item_selected", 0, 0, 94, 94);
            selected_mask:setDepth(8);
            selected_mask:setEnable(false);

            local redDot = UICreate.createUIAtlasImage(jewfImg.item_bg.mainContent, "iconantlas4", "redDot", 28, 30, 0, 0);
            redDot:setDepth(9);
            redDot:setEnable(false);
            redDot.clickScale = false;
            redDot.name = "redDot"

            list.item = jewfImg
            list.selected_mask = selected_mask
            list.redDot = redDot
            list.isShowBtnRedDot = false
            list.baoshi_limit = jewfImg.data.engrave_limit
            list.engrave_progress = self.data.jewel[i].engrave_progress
            if list.engrave_progress == 0 or list.engrave_progress == nil then
                self.openLbl_Arr[index].text = jewfImg.data.colorName .. LanUtil.formateStr(LanUtil.getValue(140901), "0%")
            else
                self.openLbl_Arr[index].text = jewfImg.data.colorName .. LanUtil.formateStr(LanUtil.getValue(140901), self.mingKeConfig["type_progress"][list.engrave_progress] .. "%")
            end
            self.suo_Arr[index].mainContent:SetActive(false);
        elseif self.data.jewel[i].id == 0 then
            if self.data.jewel[i].engrave_progress == 0 or self.data.jewel[i].engrave_progress == nil then
                self.openLbl_Arr[index].text = LanUtil.getValue(140902) .. LanUtil.formateStr(LanUtil.getValue(140901), "0%")
            else
                self.openLbl_Arr[index].text = LanUtil.getValue(140902) .. LanUtil.formateStr(LanUtil.getValue(140901), self.mingKeConfig["type_progress"][self.data.jewel[i].engrave_total] .. "%")
            end
            self.suo_Arr[index].mainContent:SetActive(false);
        elseif self.data.jewel[i].id == -1 then
            if self.data.jewel[i].engrave_progress == 0 or self.data.jewel[i].engrave_progress == nil then
                self.openLbl_Arr[index].text = LanUtil.getValue(140903) .. LanUtil.formateStr(LanUtil.getValue(140901), "0%")
            else
                self.openLbl_Arr[index].text = LanUtil.getValue(140903) .. LanUtil.formateStr(LanUtil.getValue(140901), self.mingKeConfig["type_progress"][self.data.jewel[i].engrave_total] .. "%")
            end
            self.suo_Arr[index].mainContent:SetActive(true);
        end
        self.goArr[i] = list
    end
    self:onFirstSelected()

end

function Lua_MingKePanel:showRedDot()
    local len = #self.goArr
    for i = 1, len do
        if self.goArr[i].redDot ~= nil then
            local isShowRed = true
            local lvlLimt_mingKeConfig = self.mingKeConfig["level_limit"][self.goArr[i].engrave_progress + 1]
            if lvlLimt_mingKeConfig ~= nil then
                local costItemData = self.mingKeConfig["engrave_cost"][self.goArr[i].engrave_progress + 1]
                local _len = #costItemData
                for i = 1, _len do
                    local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemData[i][1]);
                    local totalCount = costItemData[i][2]
                    if hadCount < totalCount then
                        isShowRed = false
                        break;
                    end
                end
                if isShowRed == true then
                    if self.goArr[i].baoshi_limit ~= 0 and self.goArr[i].engrave_progress < self.goArr[i].baoshi_limit then
                        isShowRed = true
                    else
                        isShowRed = false
                    end
                end
            else
                isShowRed = false
            end
            self.goArr[i].isShowBtnRedDot = isShowRed
            self.goArr[i].redDot:setEnable(isShowRed)
        end
    end
    self.redDot:setEnable(self.goArr[self.selectedIndex].isShowBtnRedDot);
    if self.goArr[self.selectedIndex].baoshi_limit == 0 then
        self.jingLianClickBtn:setEnable(false)
        self.maxTxt:setEnable(true)
        self.maxTxt.text = DataCenter.equData.equipMingKeCommonConfig["txt_tips_show"][1]
    else
        if self.goArr[self.selectedIndex].engrave_progress >= self.goArr[self.selectedIndex].baoshi_limit then
            self.jingLianClickBtn:setEnable(false);
            self.maxTxt:setEnable(true);
            self.maxTxt.text = DataCenter.equData.equipMingKeCommonConfig["txt_tips_show"][self.goArr[self.selectedIndex].engrave_progress]
        else
            self.jingLianClickBtn:setEnable(true)
            self.maxTxt:setEnable(false)
        end
    end

    if self.goArr[self.selectedIndex].engrave_progress >= #self.mingKeConfig["type_progress"] then
        self.mtObj.gameObject:SetActive(false)
    else
        self.mtObj.gameObject:SetActive(true)
    end
end

function Lua_MingKePanel.Get:mingKeConfig()
    return DataCenter.equData.equipMingKeConfig[self.data.jwelType];
end

function Lua_MingKePanel:showCostItem()
    local costType = self.data.jwelType
    local costItemList = self.mingKeConfig["engrave_cost"][self.engrave_progress + 1];
    local len = 0
    if costItemList ~= nil then
        len = #costItemList
    end
    self.costItemId = 0
    local startX = 365
    if len ~= 1 then
        startX = 320
    end
    local objLen = self.ItemList:getSize();
    for i = 1, objLen do
        self.ItemList[i]:dispose()
    end
    self.ItemList:clear()
    for i = 1, len do
        local item = Lua_ToolImage.new(self.itemContainer.gameObject);
        item:setDepth(7);
        item:setLocation(startX +(i - 1) * 90, -200, 0);
        item.data = Lua_ToolVo.new(costItemList[i][1])
        item.content.name = i
        local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemList[i][1]);
        item:showNumLimit(hadCount, costItemList[i][2], 2)
        if hadCount < costItemList[i][2] then
            self.costItemId = costItemList[i][1]
        end
        self.ItemList:add(item)
    end
end

function Lua_MingKePanel:onFirstSelected()
    if self.curPart ~= self.data.part then
        local len = #self.goArr
        self.selectedIndex = nil
        self.engrave_progress = nil
        for i = 1, len do
            if self.goArr[i].item ~= nil then
                self.selectedIndex = self.goArr[i].index
                self.engrave_progress = self.goArr[i].engrave_progress
                break
            end
        end
        self:onSelectedByIndex(self.selectedIndex)
    else
        self:onSelectedByIndex(self.selectedIndex)
    end
    self.curPart = self.data.equPart
end

function Lua_MingKePanel:onIconClick(go)
    local index = tonumber(go.transform.parent.name)
    if self.selectedIndex ~= index then
        self:onSelectedByIndex(index)
    else
        Lua_PackUtil.showItemInfo(self.goArr[index].item.data, false);
    end
end
function Lua_MingKePanel:onSelectedByIndex(value)
    local index = value
    local len = #self.goArr
    self.engrave_progress = nil
    for i = 1, len do
        if self.goArr[i].index == index then
            if self.goArr[i].selected_mask ~= nil then
                self.goArr[i].selected_mask:setEnable(true);
            end
            self.selectedIndex = self.goArr[i].index
            self.engrave_progress = self.goArr[i].engrave_progress
        else
            if self.goArr[i].selected_mask ~= nil then
                self.goArr[i].selected_mask:setEnable(false);
            end
        end
    end
    self:showCostItem()
    self:showJewlInfo()
    self:onCreateAttr(self.engrave_progress, self.cur_Attr, self.attrObj, 160)
    self:onCreateAttr(self.engrave_progress + 1, self.next_Attr, self.mtObj, 160)
    self:showRedDot()
end

function Lua_MingKePanel:showJewlInfo()
    local configInfo1 = self.mingKeConfig["type_progress"][self.engrave_progress];
    local configInfo2 = self.mingKeConfig["type_progress"][self.engrave_progress + 1];

    if configInfo1 ~= nil then
        self.attrTitle1.text = LanUtil.formateStr(LanUtil.getValue(140905), tostring(configInfo1))
    else
        self.attrTitle1.text = LanUtil.formateStr(LanUtil.getValue(140905), "0")
    end

    if configInfo2 ~= nil then
        self.attrTitle2.text = LanUtil.formateStr(LanUtil.getValue(140906), tostring(configInfo2))
    else
        self.attrTitle2.text = LanUtil.formateStr(LanUtil.getValue(140906), "0")
    end
end

function Lua_MingKePanel:getAttr(value)
    local arr = Array()
    local index = value
    if index == 0 or index > #self.mingKeConfig["type_progress"] then
        if index == 0 then
            local list = { }
            list.attrName = LanUtil.getValue(140907)
            list.value = 0
            list.index = -1
            arr:add(list)
        end
        return arr
    end
    local list = { }
    list.attrName = LanUtil.getValue(140907)
    list.value = self.mingKeConfig["stone_base_multi"][index]
    list.index = -1
    arr:add(list)
    for k, v in ipairs(Lua_ThingDefine.params) do
        local attrList = { }
        if self.mingKeConfig[v] ~= nil then
            if index ~= 0 then
                if self.mingKeConfig[v][index] ~= 0 then
                    attrList.attrName = Lua_ThingDefine.getParamName(v)
                    attrList.value = self.mingKeConfig[v][index]
                    attrList.index = Lua_ThingDefine.getParaRankByParams(v)
                    arr:add(attrList)
                end
            end
        end
    end
    arr:sort("index", false)
    return arr
end

function Lua_MingKePanel:onCreateAttr(progress, attrObjArr, go, posy)
    local attrArr = self:getAttr(progress)
    local len = attrArr:getSize()
    local _attrArr = attrObjArr
    local startY = posy
    for i = 1, len do
        if _attrArr[i] == nil then
            local label = UICreate.createLabel(go.gameObject, "", 235, startY, 265, 30, 22);
            label.overflowMethod = UILabel.Overflow.ResizeHeight
            label.pivot = UIWidget.Pivot.TopLeft;
            label:setDepth(5);
            label:setLocation(250, startY, 0);
            label.text = "[3F6180]" .. attrArr[i].attrName .. "：[13a100]+" .. attrArr[i].value .. "%"
            startY = startY - label.height - 10
            _attrArr:add(label)
        else
            _attrArr[i]:setLocation(250, startY, 0);
            _attrArr[i].text = "[3F6180]" .. attrArr[i].attrName .. "：[13a100]+" .. attrArr[i].value .. "%"
            startY = startY - _attrArr[i].height - 10
        end
    end
    local objLen = _attrArr:getSize();
    if objLen > len then
        for i = len + 1, objLen do
            _attrArr[i].text = ""
        end
    end
end

function Lua_MingKePanel:dispose()
    if self.jingLian_DragList ~= nil then
        self.jingLian_DragList:dispose();
    end
    if self.right_DragList ~= nil then
        self.right_DragList:dispose();
    end
    if self.goArr ~= nil then
        local len = #self.goArr
        for i = 1, len do
            if self.goArr[i].item ~= nil then
                self.goArr[i].item:dispose();
                self.goArr[i].selected_mask:dispose();
                self.goArr[i].redDot:dispose();
            end
        end
        self.goArr = nil;
    end
    self:superCall("dispose");
end