checkRequire("Lua_QiangHuaUtil")-- jewel_part
Lua_TiHuanWindow = class("Lua_TiHuanWindow", Lua_Window);
function Lua_TiHuanWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TiHuanWindow";
	self.skinName = "TiHuan_skin";
	self.isClickClose = true;
end

function Lua_TiHuanWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("onTiHuanCellClick", self, self.onTiHuanCellClick);

	self.tihuan_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 380, 432));
	self.tihuan_DragList:setLocation(0, -35, 0);
	self.tihuan_DragList:setListCell(Lua_TiHuanItem, 126, 380, 1);

	self._showData = Lua_WindowUtil.getWinData("Lua_TiHuanWindow", true);
	self.plusArr = self._showData.plus_Arr;
	self._clickGo = self._showData.clickGo;
	self.parentName = self._showData.parentName;
	self.equipData = self._showData.data;

	local length = self.plusArr:getSize();
	local isbool = false;
	for i = 1, length do
		if self._clickGo.name == self.plusArr[i].mainContent.name then
			isbool = true;
			break;
		end
	end

	self.tihuanBtn:setEnable(false);
	if isbool == false then
		-- 替换window
		self.titleNameLab.text = LanUtil.getValue(110583);
		self.xiexiaBtn:setEnable(true);
		self.xiexiaBtn:addClickFuntion(self, self.onXieXiaClick);
	else
		-- 镶嵌window
		self.titleNameLab.text = LanUtil.getValue(110585);
		self.xiexiaBtn:setEnable(false);
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local value = Lua_QiangHuaUtil.getJewel_part(self._showData.part);
	if value == 0 then
		self.Arr = bagData:getItemsBySubType( { Lua_PackTypeDefine.ATT_JEWL });
	elseif value == 1 then
		self.Arr = bagData:getItemsBySubType( { Lua_PackTypeDefine.DEF_JEWL });
	end

	self.Arr:sort("rank", true);
	if value == 0 then
		local id = Lua_QiangHuaUtil.getJewel_show(1);
		local jewlShowVo = Lua_ToolVo.new(id);
		jewlShowVo.isShow = true;
		if isbool == true then
			self.Arr:add(jewlShowVo);
		else
			if self.equipData.jewel[tonumber(self.parentName)].id < id then
				self.Arr:add(jewlShowVo);
			end
		end
	elseif value == 1 then
		local id = Lua_QiangHuaUtil.getJewel_show(2);
		local jewlShowVo = Lua_ToolVo.new(id);
		jewlShowVo.isShow = true;
		if isbool == true then
			self.Arr:add(jewlShowVo);
		else
			if self.equipData.jewel[tonumber(self.parentName)].id < id then
				self.Arr:add(jewlShowVo);
			end
		end
	end
	self.tihuan_DragList:setLuaArrayData(self.Arr, false);
end

function Lua_TiHuanWindow:onTiHuanClick()
	if self.data == nil then
		return;
	end

	-- print("打印",self._showData.part,tonumber(string.sub(self.parentName, -1, -1)) -1,self.data.index)
	local cmd = ProtoPublic_pb.Proto11400617();
	cmd.part = self._showData.part;
	cmd.jewel_hole = tonumber(string.sub(self.parentName, -1, -1)) -1;
	cmd.pkg_index = self.data.index;
	sendMsg(11400617, cmd);
	self:hide();
end

function Lua_TiHuanWindow:onXieXiaClick()
	local cmd = ProtoPublic_pb.Proto11400626();
	cmd.part = self._showData.part;
	cmd.jewel_index = tonumber(string.sub(self.parentName, -1, -1)) -1;
	sendMsg(11400626, cmd);
	self:hide();
end

function Lua_TiHuanWindow:onTiHuanCellClick(data)
	self.data = data;
	self:onTiHuanClick();
end

function Lua_TiHuanWindow:dispose()
	if self.tihuan_DragList ~= nil then
		self.tihuan_DragList:dispose();
		self.tihuan_DragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TiHuanItem = class("Lua_TiHuanItem", Lua_ListCell);
function Lua_TiHuanItem:ctor(p)
    self:superCall("ctor", p, "TiHuanItem_skin");
end
function Lua_TiHuanItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(-132, 2, 0);
end

function Lua_TiHuanItem:setData(data)
    self._data = data;
    if data == nil then
    	return;
    end

    if self._data.isShow ~= nil and self._data.isShow == true then
        self.itemShow:setEnable(true);
    else
        self.itemShow:setEnable(false);
    end
    self.itemImg.data = Lua_ToolVo.new(self._data.id, self._data.count, self._data.bind);
    self.itemTxt.text = self.itemImg.data.colorName;

    self.selectIcon:setEnable(self._data.selected); -- 一直是false，Lua_XiangQianPanel
end

function Lua_TiHuanItem:onPlayerSoundClick(go)
	if self._data.isShow ~= nil and self._data.isShow == true then
		local isMustOpen = true;
		if self._data.timeputDes ~= nil then
			local openWinInfo;
			for k, v in ipairs(self._data.timeputDes) do
				if v.openWin ~= nil and Lua_PackUtil.checkOpenWinFunOpen(v.openWin) then
					openWinInfo = v.openWin[1];
					if openWinInfo ~= nil and openWinInfo.winName ~= nil and openWinInfo.winName == "Lua_ShopWindow" 
						and openWinInfo.itemID ~= nil then
						if type(openWinInfo.itemID) == "table" then
							itemID = openWinInfo.itemID[DataCenter.roleData.career];
						elseif type(openWinInfo.itemID) == "number" then
							itemID = openWinInfo.itemID;
						end
						Lua_PackUtil.openWinByList(v.openWin, nil, nil, false, itemID);
						isMustOpen = false;
						break;
					end
				end
			end
		end
		if isMustOpen then
			Lua_WindowUtil.openWin("Lua_ShopWindow");
		end
		Lua_WindowUtil.openWin("Lua_TiHuanWindow", WinParam.ACTION_CLOSE);
	else
		Lua_MsgUtil.callFunc("onTiHuanCellClick", self._data);
	end
end

function Lua_TiHuanItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end