checkRequire("Lua_ForgingPanel"); -- 鍛造
checkRequire("Lua_BaoShiPanel"); -- 寶石
checkRequire("Lua_CuiLianPanel"); -- 套裝
checkRequire("Lua_RongHePanel"); -- 熔合
checkRequire("Lua_ShenLianPanel"); -- 神煉
Lua_ForgingWindow = class("Lua_ForgingWindow", Lua_FullSizeTabWindow);
function Lua_ForgingWindow:ctor()
	self.list = Array();
	self.list:add({name = LanUtil.getValue(120555), panel = Lua_ForgingPanel, openId = 10006, eventIds = {10801, 10807, 10808, 10806}, titleAltas = "titleName_altas_1", titleSprite = "duanzao"});
	self.list:add({name = LanUtil.getValue(120577), panel = Lua_BaoShiPanel, openId = 10060, eventIds = {10804, 10810, 10815}, titleAltas = "titleName_altas_1", titleSprite = "duanzao"});
	self.list:add({name = LanUtil.getValue(110552), panel = Lua_CuiLianPanel, openId = 10070, eventIds = {10803}, titleAltas = "titleName_altas_1", titleSprite = "duanzao"});
	self.list:add({name = LanUtil.getValue(110554), panel = Lua_RongHePanel, openId = 10082, eventIds = {17002, 17003, 16002}, titleAltas = "titleName_altas_1", titleSprite = "duanzao"});
	self.list:add({name = LanUtil.getValue(128904), panel = Lua_ShenLianPanel, openId = 10182, eventIds = {10811, 10812}, titleAltas = "titleName_altas_1", titleSprite = "duanzao"});

	self:superCall("ctor", self.list);
	self.windowName = "Lua_ForgingWindow";
end

function Lua_ForgingWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:checkBtnRedDot();
	self:onUpdateXiLianIcon();
	DataCenter.equData.ForgingWindowData = Lua_WindowUtil.getWinData("Lua_ForgingWindow", true);
	
	self:addLuaEvent("UPDATE_RONGLIAN_REDDOT", self, self.checkBtnRedDot);
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateXiLianIcon);
	self:addLuaEvent("PACK_UPDATE", self, self.onUpdateXiLianIcon);
end

function Lua_ForgingWindow:checkBtnRedDot()
	local redDotData = DataCenter.equData:getRonglianRedData();
	local len = redDotData:getSize();
	if len > 0 then
		self:setRedDotStateByIndex(4, true);
	else
		self:setRedDotStateByIndex(4, false);
	end
end

function Lua_ForgingWindow:onUpdateXiLianIcon()
	if DataCenter.funcOpenData:isOpened(10071) == true then
		local item_amount = Lua_CuiLianUtil.getLock_cost(1)[2];
		local item_id = Lua_CuiLianUtil.getLock_cost(1)[1];
		local curNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(item_id);
		if DataCenter.equData.free_polish_times > 0 or curNum >= item_amount then
			self:setRedDotStateByIndex(1, true);
		else
			self:setRedDotStateByIndex(1, false);
		end
	end
end

function Lua_ForgingWindow:showWin(param)
	self:superCall("showWin", param);

	if self.showData ~= nil and type(self.showData) == "number" then
		self:setSelected(self.showData, true);
	elseif self.showData ~= nil and self.showData.openIdx ~= nil then
		self:setSelected(self.showData.openIdx, true);
	end
end

function Lua_ForgingWindow:setSelected(val)
	self:superCall("setSelected", val);
end