Lua_XiangQianPanel = class("Lua_XiangQianPanel", Lua_DisplayObject);
function Lua_XiangQianPanel:ctor(p)
	self:superCall("ctor", p, "XiangQianPanel_skin");
end

function Lua_XiangQianPanel:buildShowItem()
	self:superCall("buildShowItem");

	Lua_EquipData.XIANGQIAN_TO_PACK = 1;

	self:addLuaEvent("onXiangQianCellClick", self, self.onXiangQianCellClick);
	self:addLuaEvent("EQU_UPDATE", self, self.onUpdateView);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.onUpdateRedDot);

	self.tipsLbl.text = LanUtil.getValue(110556);

	self.iconBg:addClickFuntion(self, self.onIconBgClick)
	self.jiahao1:addClickFuntion(self, self.onOpenTiHuanClick)
	self.jiahao2:addClickFuntion(self, self.onOpenTiHuanClick)
	self.jiahao3:addClickFuntion(self, self.onOpenTiHuanClick)
	self.jiahao4:addClickFuntion(self, self.onOpenTiHuanClick)
	self.jiahao6:addClickFuntion(self, self.onOpenTiHuanClick)
	self.jiahao5:addClickFuntion(self, self.onOpenTiHuanClick)
	self.iconBg1:addClickFuntion(self, self.onIconClick);

	self.suo_Arr = Array();
	self.suo_Arr:add(self.suo1);
	self.suo_Arr:add(self.suo2);
	self.suo_Arr:add(self.suo3);
	self.suo_Arr:add(self.suo4);
	self.suo_Arr:add(self.suo6);
	self.suo_Arr:add(self.suo5);

	self.plus_Arr = Array();
	self.plus_Arr:add(self.jiahao1);
	self.plus_Arr:add(self.jiahao2);
	self.plus_Arr:add(self.jiahao3);
	self.plus_Arr:add(self.jiahao4);
	self.plus_Arr:add(self.jiahao6);
	self.plus_Arr:add(self.jiahao5);

	local bc;
	for i = 1, 6 do
		bc = self.plus_Arr[i].mainContent:GetComponent("BoxCollider");
		bc.isTrigger = true;
		bc.center = Vector3(0, 0, 0);
		bc.size = Vector3(76, 76, 0);
	end

	self.openLabBg_Arr = Array();
	self.openLabBg_Arr:add(self.openLabBg1);
	self.openLabBg_Arr:add(self.openLabBg2);
	self.openLabBg_Arr:add(self.openLabBg3);
	self.openLabBg_Arr:add(self.openLabBg4);
	self.openLabBg_Arr:add(self.openLabBg6);
	self.openLabBg_Arr:add(self.openLabBg5);

	self.openLbl_Arr = Array();
	self.openLbl_Arr:add(self.openLbl1);
	self.openLbl_Arr:add(self.openLbl2);
	self.openLbl_Arr:add(self.openLbl3);
	self.openLbl_Arr:add(self.openLbl4);
	self.openLbl_Arr:add(self.openLbl6);
	self.openLbl_Arr:add(self.openLbl5);

	self.duanzaoBG_Arr = Array();
	self.duanzaoBG_Arr:add(self.forging_duanzao1);
	self.duanzaoBG_Arr:add(self.forging_duanzao2);
	self.duanzaoBG_Arr:add(self.forging_duanzao3);
	self.duanzaoBG_Arr:add(self.forging_duanzao4);
	self.duanzaoBG_Arr:add(self.forging_duanzao6);
	self.duanzaoBG_Arr:add(self.forging_duanzao5);

	self.hongdianArr = {};
	for i = 1, 6 do
		local index = i
		if i == 5 then
			index = i + 1
		elseif i == 6 then
			index = i - 1
		end

		local hongdian = UICreate.createUIAtlasImage(self.duanzaoBG_Arr[index].mainContent, "common_atlas_1", "ui_common_hongdian", 30, 30, 0, 0)
		hongdian:setDepth(15);
		hongdian.clickScale = false;
		hongdian.name = "hongdian"
		hongdian:setEnable(false);
		self.hongdianArr[index] = hongdian
	end

	for i = 3, self.plus_Arr:getSize() do
		self.plus_Arr[i].mainContent:SetActive(false)
	end
	self.suo_Arr[1].mainContent:SetActive(false);
	self.suo_Arr[2].mainContent:SetActive(false);

	self.lblList = {[1] = "", [2] = "", [3] = "[ff2929]" .. LanUtil.getValue(110591), [4] = "[ff2929]" .. LanUtil.getValue(110592), [5] = "[ff2929]" .. LanUtil.getValue(110593), [6] = "[ff2929]" .. LanUtil.getValue(120554) };
	-- 7阶
	self.openLbl_Arr[3].text = self.lblList[3];
	self.openLabBg_Arr[3]:SetDimensions(self.openLbl_Arr[3].width + 35, self.openLbl_Arr[3].height + 20);
	-- 9阶
	self.openLbl_Arr[4].text = self.lblList[4];
	self.openLabBg_Arr[4]:SetDimensions(self.openLbl_Arr[4].width + 35, self.openLbl_Arr[4].height + 20);
	-- 11阶
	self.openLbl_Arr[5].text = self.lblList[6];
	self.openLabBg_Arr[5]:SetDimensions(self.openLbl_Arr[5].width + 35, self.openLbl_Arr[5].height + 20);
	-- vip5
	self.openLbl_Arr[6].text = self.lblList[5];
	self.openLabBg_Arr[6]:SetDimensions(self.openLbl_Arr[6].width + 35, self.openLbl_Arr[6].height + 20);

	self.xiangqian_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 542));
	self.xiangqian_DragList:setListCell(Lua_XiangQianItem, 116, 286, 1);
	self.xiangqian_DragList:setLocation(-460, -70, 0);

	self.Arr = Array();
	self.equipArr = DataCenter.equData.parts;
	if #self.equipArr ~= 0 then
		local _eq;
		for i = 12, 1, -1 do
			_eq = DataCenter.equData:getEquByPart(i);
			self.Arr:add(_eq);
		end
	end
	self.xiangqian_DragList:setLuaArrayData(self.Arr, false);
	self.length = self.xiangqian_DragList.showList:getSize();

	if self.length ~= 0 then
		self.xiangqian_DragList.showList[1]:onPlayerSoundClick();
		self.xiangqian_DragList:setSelected(1);
	end
	self:onChangeInfo()
end

function Lua_XiangQianPanel:onIconBgClick()
	if DataCenter.funcOpenData:isOpened(10033) == true then
		Lua_EquipData.XIANGQIAN_TO_PACK = 2
		Lua_WindowUtil.openWin("Lua_ForgingWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_OPEN, 2);
	else
		local cfg = getConfig( { "func_open", 10033 });
		if cfg ~= nil and cfg.advance_message ~= nil then
			OperateAlert.show(cfg.advance_message);
		end
	end
end

function Lua_XiangQianPanel:onXiangQianCellClick(data)
	self.data = data;
	if self.data == nil then
		return;
	end
	self:onShowInfo()
end

function Lua_XiangQianPanel:onUpdateRedDot()
	self:onShowInfo();
	for i = 1, self.xiangqian_DragList.showList:getSize() do
		self.xiangqian_DragList.showList[i]:showRedDot();
	end
end

function Lua_XiangQianPanel:onShowInfo()
	if self.data == nil then
		return;
	end

	if self.goArr == nil then
		self.goArr = Array();
	else
		for i = 1, self.goArr:getSize() do
			self.goArr[i]:dispose();
			-- self.goArr[i] = nil;
		end
	end

	if self.equipImg == nil then
		self.equipImg = Lua_ToolImage.new(self.content);
		self.equipImg:setDepth(6);
		self.equipImg:setLocation(104, -33, 0);
	end
	self.equipImg.data = self.data;

	self.count = DataCenter.equData:getJewf_countHoleByPart(self.data.equPart);
	self.count2 = DataCenter.equData:getJewf_countByPart(self.data.equPart);
	-- print("count", self.count, self.count2)
	for i = 1, self.count do
		-- 已经解锁的
		local index = i;
		if i == 5 then
			-- 5：vip5 ,6：十一阶p
			index = i + 1
		elseif i == 6 then
			index = i - 1
		end

		if self.data.jewel[i].id > 0 then
			-- 解锁有宝石
			-- 创建宝石
			self.jewfImg = Lua_ToolImage.new(self.duanzaoBG_Arr[index].mainContent);
			self.jewfImg:setDepth(6);
			self.jewfImg:setLocation(0, 0, 0);
			self.jewfImg.content.name = i;
			self.jewfImg:setCanClick(true);
			--   end
			self.jewfImg.data = Lua_ToolVo.new(self.data.jewel[i].id, 0, 0);
			self.jewfImg.item_bg:addClickFuntion(self, self.onOpenTiHuanClick);
			self.jewfImg:removeFun(false);
			self.goArr:add(self.jewfImg);
			-- 去掉锁 加号
			self.suo_Arr[index].mainContent:SetActive(false);
			self.plus_Arr[index].mainContent:SetActive(false);
			self.hongdianArr[index]:setEnable(self:checkRedDot(self.data.jewel[i].id));
			-- 显示宝石文字说明
			self.openLbl_Arr[index]:setEnable(true);
			self.openLabBg_Arr[index]:setEnable(true);
			local _dataArr = Array();
			local _str;
			for k, v in pairs(self.jewfImg.data.attribute) do
				_str = Lua_CuiLianUtil.getAttr_name(k);
				_dataArr:add({str = _str, value = v});
				-- print("测试", self.jewfImg.data.name, k, v, _str);
			end

			if _dataArr[2] == nil then
				self.openLbl_Arr[index].text = "[00E125]" .. self.jewfImg.data.name .. "\n" .. 
				string.format(_dataArr[1].str, _dataArr[1].value);
			else
				self.openLbl_Arr[index].text = "[00E125]" .. self.jewfImg.data.name .. "\n" .. 
				string.format(_dataArr[1].str, _dataArr[1].value) .. string.format(_dataArr[2].str, _dataArr[2].value);
			end
			self.openLabBg_Arr[index]:SetDimensions(self.openLbl_Arr[index].width + 35, self.openLbl_Arr[index].height + 20);
		elseif self.data.jewel[i].id == 0 then
			-- 解锁无宝石
			-- 显示加号
			self.hongdianArr[index]:setEnable(self:checkRedDot(self.data.jewel[i].id));
			self.plus_Arr[index].mainContent:SetActive(true);
			-- 隐藏文字说明
			self.openLbl_Arr[index]:setEnable(false);
			self.openLabBg_Arr[index]:setEnable(false);
			-- 隐藏锁
			self.suo_Arr[index].mainContent:SetActive(false);
		elseif self.data.jewel[i].id == -1 then
			-- 没有解锁的
			self.plus_Arr[index]:setEnable(false);
			self.suo_Arr[index].mainContent:SetActive(true);
			self.hongdianArr[index]:setEnable(false);

			self.openLbl_Arr[index]:setEnable(true);
			self.openLbl_Arr[index].text = self.lblList[i];
			self.openLabBg_Arr[index]:setEnable(true);
			self.openLabBg_Arr[index]:SetDimensions(self.openLbl_Arr[index].width + 35, self.openLbl_Arr[index].height + 20);
		end
	end
end

function Lua_XiangQianPanel:checkRedDot(id)
	-- 解孔的数量 与镶嵌宝石的数量对比。
	local value = Lua_QiangHuaUtil.getJewel_part(self.data.equPart);
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local jewlCount = 0;
	for i = 1, self.count do
		if self.data.jewel[i].id >= 0 then
			jewlCount = jewlCount + 1
		end
	end

	local Arr = Array();
	local jewelArr = Array();
	if value == 0 then
		Arr = bagData:getItemsBySubType( { Lua_PackTypeDefine.ATT_JEWL });
	elseif value == 1 then
		Arr = bagData:getItemsBySubType( { Lua_PackTypeDefine.DEF_JEWL });
	end

	local arrLen = Arr:getSize();
	if arrLen ~= 0 then
		Arr:sort("rank", true);
	else
		return false
	end

	if jewlCount < self.count2 then
		return arrLen > 0;
	else
		if id > 0 then
			local idRank = Lua_ToolVo.new(id, 0, 0).rank;
			return idRank < Arr[1].rank;
		else
			return arrLen > 0;
		end
	end
end

function Lua_XiangQianPanel:onUpdateView()
	self:onChangeInfo()
	self.Arr:clear();
	self.equipArr = DataCenter.equData.parts;
	if #self.equipArr ~= 0 then
		for i = 12, 1, -1 do
			local _eq = DataCenter.equData:getEquByPart(i);
			-- if _eq ~= nil then
				self.Arr:add(_eq);
			-- end
		end

		for i = 1, self.Arr:getSize() do
			if self.data.equPart == self.Arr[i].equPart then
				-- print("更新", self.data.equPart, self.Arr[i].equPart);
				self.data = self.Arr[i];
				self.Arr[i].selected = true;
			else
				self.Arr[i].selected = false;
			end
		end
		self.xiangqian_DragList:setLuaArrayData(self.Arr, false);
		self:onShowInfo();
	end
end

function Lua_XiangQianPanel:onIconClick()
	Lua_WindowUtil.openWin("Lua_AdditionWindow", WinParam.ACTION_AUTO, {str = "jewel_attr", value = DataCenter.equData.jewel});
end

function Lua_XiangQianPanel:onChangeInfo()
	if DataCenter.equData.jewel ~= nil and DataCenter.equData.jewel ~= 0 and DataCenter.funcOpenData:isOpened(10060) == true then
		self.lvlTxt.text = "+" .. DataCenter.equData.jewel;
	else
		self.lvlTxt.text = "";
	end
end

function Lua_XiangQianPanel:onOpenTiHuanClick(go)
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_TiHuanWindow", WinParam.ACTION_AUTO, {part = self.data.equPart, clickGo = go, 
	plus_Arr = self.plus_Arr, data = self.data, parentName = go.transform.parent.name});
end

function Lua_XiangQianPanel:dispose()
	if self.xiangqian_DragList ~= nil then
		self.xiangqian_DragList:dispose();
		self.xiangqian_DragList = nil;
	end
	if self.suo_Arr ~= nil then
		self.suo_Arr:dispose();
		self.suo_Arr:clear();
		self.suo_Arr = nil;
	end
	if self.plus_Arr ~= nil then
		self.plus_Arr:dispose();
		self.plus_Arr:clear();
		self.plus_Arr = nil;
	end
	if self.openLbl_Arr ~= nil then
		self.openLbl_Arr:dispose();
		self.openLbl_Arr:clear();
		self.openLbl_Arr = nil;
	end
	if self.duanzaoBG_Arr ~= nil then
		self.duanzaoBG_Arr:dispose();
		self.duanzaoBG_Arr:clear();
		self.duanzaoBG_Arr = nil;
	end
	self.jewfImg = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_XiangQianItem = class("Lua_XiangQianItem", Lua_ListCell);
function Lua_XiangQianItem:ctor(p)
	self:superCall("ctor", p, "XiangQianItem_skin");
end

function Lua_XiangQianItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-93.5, 2.5, 0);

	self.kongdiArr = Array();
	self.kongdiArr:add(self.kongdi1);
	self.kongdiArr:add(self.kongdi2);
	self.kongdiArr:add(self.kongdi3);
	self.kongdiArr:add(self.kongdi4);
	self.kongdiArr:add(self.kongdi5);
	self.kongdiArr:add(self.kongdi6);

	self.hongbaoshiArr = Array();
	self.hongbaoshiArr:add(self.hongdi1);
	self.hongbaoshiArr:add(self.hongdi2);
	self.hongbaoshiArr:add(self.hongdi3);
	self.hongbaoshiArr:add(self.hongdi4);
	self.hongbaoshiArr:add(self.hongdi5);
	self.hongbaoshiArr:add(self.hongdi6);

	self.lanbaoshiArr = Array();
	self.lanbaoshiArr:add(self.landi1);
	self.lanbaoshiArr:add(self.landi2);
	self.lanbaoshiArr:add(self.landi3);
	self.lanbaoshiArr:add(self.landi4);
	self.lanbaoshiArr:add(self.landi5);
	self.lanbaoshiArr:add(self.landi6);
end

function Lua_XiangQianItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data;
	self.maxLvl = self._data.maxLvl;

	if self._data.intensifyLevel == 0 then
		self.itemTxt.text = self.itemImg.data.colorName
	elseif self._data.intensifyLevel == self.maxLvl then
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
	else
		self.itemTxt.text = self.itemImg.data.colorName .. "[" .. self.itemImg.data.colorStr .. "]" .. "+" .. data.intensifyLevel;
	end

	self.count = DataCenter.equData:getJewf_countHoleByPart(self._data.equPart);
	self.count2 = DataCenter.equData:getJewf_countByPart(self._data.equPart);
	self.jewlCount = 0;
	self.isRed = false;
	for i = 1, self.count do
		if i <= self.count2 then
			self.kongdiArr[i].mainContent:SetActive(true);
		else
			self.kongdiArr[i].mainContent:SetActive(false);
		end

		if self._data.jewel[i].id > 0 then
			self.jewlCount = self.jewlCount + 1
		end
		self.hongbaoshiArr[i].mainContent:SetActive(false);
		self.lanbaoshiArr[i].mainContent:SetActive(false);
	end

	for i = 1, self.count do
		if self._data.jewel[i].id > 0 then
			if Lua_ToolVo.new(self._data.jewel[i].id, 0, 0).subType == 101 then
				self.isRed = true;
				break;
			end
		end
	end

	for i = 1, self.jewlCount do
		if self.isRed == true then
			self.hongbaoshiArr[i].mainContent:SetActive(true);
			self.lanbaoshiArr[i].mainContent:SetActive(false);
		else
			self.hongbaoshiArr[i].mainContent:SetActive(false);
			self.lanbaoshiArr[i].mainContent:SetActive(true);
		end
	end

	-- self.itemBg:setAltas("common_atlas_1", data.selected and "ui_common_widget_x1" or "ui_common_widget_x2");
	self:showRedDot();
end

function Lua_XiangQianItem:showRedDot()
	self.redDot:setEnable(self:checkRedDot());
end

function Lua_XiangQianItem:checkRedDot()
	-- 解孔的数量 与镶嵌宝石的数量对比。
	local value = Lua_QiangHuaUtil.getJewel_part(self._data.equPart);
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	-- 确定镶嵌的宝石类型
	local Arr = Array();
	local jewelArr = Array();
	if value == 0 then
		Arr = bagData:getItemsBySubType( { Lua_PackTypeDefine.ATT_JEWL });
	elseif value == 1 then
		Arr = bagData:getItemsBySubType( { Lua_PackTypeDefine.DEF_JEWL });
	end

	local arrLen = Arr:getSize();
	if arrLen ~= 0 then
		Arr:sort("rank", true);
	else
		return false;
	end

	if self.jewlCount < self.count2 then
		return arrLen > 0;
	else
		-- 检查是否有可升级的宝石 镶嵌数量大于等于解孔数量
		for i = 1, self.count do
			if self._data.jewel[i].id > 0 then
				local list = {};
				list.rank = Lua_ToolVo.new(self._data.jewel[i].id, 0, 0).rank
				jewelArr:add(list);
			end
		end

		if jewelArr:getSize() ~= 0 then
			jewelArr:sort("rank", false);
			return jewelArr[1].rank < Arr[1].rank;
		else
			return false;
		end
	end
end

function Lua_XiangQianItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("onXiangQianCellClick", self._data);
end

function Lua_XiangQianItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_XiangQianItem:dispose()
	self:superCall("dispose");
end